//This file is "cal_conc_LRO.cc"
//Definition of a member function of class Lattice.
//Calculates the concentration of atomic species and also 
//accumulates the no. of instances for each atomic species
//at each site. The latter is for finding LRO.
//By Teck Leong Tan

#include "lattice.h"
//extern int num_type, nsize;

void Lattice:: cal_conc_LRO()
{
  C_struct.conc.assign((num_type+1),0.0);//num_type+1 to include zeroth atom type
  C_struct.amount.assign((num_type+1),0);//amount= conc * natoms 
  
  int tempd=0;
  //Loop over num of atomic species-1
  for (int type=0;type<=num_type;type++)
  { 
    //Loop over cell
    for (int ijk=0; ijk<nsize;ijk++)
    {
      //Loop over no. of sublattices
      for (int l=0; l<num_sublat;l++)
      {
        if (noccupancy[ijk].site[l].atomtype==type)
        {
          C_struct.amount[type]+=1;
          noccupancy[ijk].site[l].LRO_instances[type]+=1;
          //cout<<"Accumulating"<<endl;
        }
        
      }//end for (int l=0; l<num_sublat;l++)
    }//end for (int ijk=0; ijk<nsize;ijk++)
  }//end for (int type=1;type<=num_type;type++)  

  /*for (int i=1;i<=num_type;i++)
  {
    tempd+=C_struct.amount.at(i);
  }
  C_struct.amount[0]=natoms-tempd;*/
  for (int i=0;i<=num_type;i++)
  {
    
    C_struct.conc[i]=(double)C_struct.amount[i]/(double)natoms;
  }
  for (int i=0;i<=num_type;i++)
  {
   //cout<<"conc["<<i<<"]= "<<C_struct.conc[i]<<endl;
  }
  
}

//EOF




