//This file is cal_corr_disorder.cc
//Function definition of memeber func of Lattice class.
//This func. calculates the correlation disorder
//By Teck Leong Tan

#include "lattice.h"

void Lattice::cal_corr_disorder(Inversion& Inv)
{
  double conc_n;//Multiplication of concentrations 
  Inv.Edisorder=Inv.J[0];//Disorder energy=J*(conc^n)*degeneracy*(1/n) for binary
  Inv.corr_disorder.assign(Inv.J.size(),0);
  Inv.corr_disorder[0]=1;//The zero body correlation term is always 1
  //cout<<"Jsize= "<<Inv.J.size()<<" corr_disorder.size= "<<Inv.corr_disorder.size()<<endl;
  //cout<<"nsize= "<<Inv.n_index.size()<<" fsize= "<<Inv.f_index.size()<<endl;
  /*for (int i=0;i<Inv.n_index.size();i++)
  {
    cout<<Inv.n_index[i]<<" "<<Inv.f_index[i]<<" "<<Inv.type_index[i]<<endl;
   
  }*/
  //Loop over no. of unique interactions, J
  for (int i=1; i<Inv.J.size();i++)
  {
    vector<int>atomtypes;//Atom types forming the cluster
    atomtypes.assign(Inv.n_index[i],0);
    tensor_index(Inv.n_index[i], Inv.type_index[i], atomtypes);
    conc_n=1; 
    for (int j=0;j<atomtypes.size();j++)
    {
     // cout<<"type: "<<atomtypes[j]<<endl;
      conc_n*=Inv.phi[0][atomtypes[j]+1];//The correct atom index needs to be increase by 1;
    }  
    //cout<<"conc_n: "<<conc_n;
    //cout<<"degen: "<<clustree.sublat[0].nbody[Inv.n_index[i]].f_degen[Inv.f_index[i]]<<endl;
    Inv.corr_disorder[i]=conc_n*clustree.sublat[0].nbody[Inv.n_index[i]].\
                         f_degen[Inv.f_index[i]]/(double)Inv.n_index[i];
    Inv.Edisorder+=Inv.J[i]*Inv.corr_disorder[i];
  } 

}
//EOF
