//This file is cv1.cc 
//Definition of func. of class Inversion
//This func. calculates the CV -1 score of the sturctural inversion
//By Teck Leong Tan

#include "inversion.h"

extern double Vlargenum;
double VVlargenum=2*Vlargenum;

void Inversion::cv1_slow()
{
 // double VVlargenum=Vlargenum+2*Vlargenum;
  vector<double> minus_row;//Stores the ith row of phi that is removed
  double minus_E;//Stores the energy corresponding to the removed ith row
  double predict_E;//Predicted energy;
  int size=phi[0].size();
  set_param();
  cv1_score.push_back(0);
  //Loop over no. of data sets i.e length of vector E
  for (int i=0; i<E.size();i++)
  {
    minus_E=E[i];
    minus_row=phi[i];
    cout<<"sizeof minus_row= "<<minus_row.size()<<endl;
    E[i]=0;//As good as removing the ith row
    phi[i].assign(size,0);//As good as removing the ith row
    lfit();//Invert sturcture.
     
    //Calculate CV -1 score
    predict_E=0;
    for(int j=0;j<size;j++)
    {
      predict_E+=(J[j]*minus_row[j]);
    }
    cv1_score.back()+=((minus_E-predict_E)*(minus_E-predict_E));

    //Put back the removed row;
    phi[i]=minus_row;
    E[i]=minus_E;
  }
  cv1_score.back()=cv1_score.back()/E.size();
  cout<<"cv1_slow done"<<endl;
}

void Inversion::cv1_fast()
{
  //Note cv1_fast() should only be done after doing a full
  //least square fit, i.e lfit(); 
  if(issingular){
    cv1_score.push_back(VVlargenum);
    return;
  }   
  vector<double> phi_irow;//ith row of phi;
  vector<double> tempvec;
  double temp, factor ;
  double predict_E;
  cv1_score.push_back(0);
  //Loop over no. of data sets i.e length of vector E
  for (int i=0; i<E.size();i++)
  {
    predict_E=0;
    for(int j=0;j<phi[i].size();j++)
    {
      predict_E+=(J[j]*phi[i][j]);
    }

    //Calculate factor
    phi_irow=phi[i];
    tempvec.assign(phi_irow.size(),0);
    if (covar.size()!=phi[0].size())
    {
      cout<<"Error in cv1.cc: covar.size() should equal phi[o].size()"<<endl;
      exit(1);
    }
    //Matrix multiplication of phi_irow * covar = tempvec 
    for (int j=0; j<covar.size();j++)
    {
      for (int k=0; k<covar[j].size();k++)
      {
        tempvec[j]+=(phi_irow[k]*covar[j][k]);
      }
    }
    //Factor = tempvec dot phi_irow;
    factor=dot_product(tempvec, phi_irow);

    temp=(E[i]-predict_E)/(1-factor);
    cv1_score.back()+=(temp*temp);
  }
  cv1_score.back()=cv1_score.back()/E.size();
  cout<<"cv1_fast() done"<<endl;
}
//EOF








