//This file is eEnergy.cc
//Function definition of memeber function of Lattice class.
//By Teck Leong Tan

#include "lattice.h"

//This function calculates the energy of the system 

double Lattice::eEnergy()
{  
  //int noccu;
  double E0=0;
  E0+=get_Vin(0, 0, 0, 0);//Contribution from 0-body Vin 
  
  //Loop over cell (ijk)
  for (int ijk=0; ijk<nsize;ijk++)
  {
    //Loop over sublattice
    for (int ll=0; ll<num_sublat;ll++)
    {
      //E0+=get_Vin(ll, 0, 0, 0);//Contribution from 0-body Vin
      
      //Loop over nbody
      for (int n=1;n<maxbody+1;n++)
      {
        //Loop over cluster types
        for (int f=0;f<clustree.sublat[ll].nbody[n].nclus.size();f++)
        {
          //Loop over degeneracy
          for(int d=0;d<clustree.sublat[ll].nbody[n].nclus[f]->nsym.size();d++)
          {
	          int c_ijkl [n][2];//Stores the ijk l of atoms in the cluster
	          int c_occu [n];//Stores the atomtypes of the cluster
	          c_occu[0]=noccupancy[ijk].site[ll].atomtype;
	          int product=noccupancy[ijk].site[ll].atomtype;//Product of all elements in c_occu
	          double V_old=0;//Vin of present cluster

            //Loop over neighbor references
            for (int r=1;r<n;r++)
            {
              int temp;
              temp=clustree.sublat[ll].nbody[n].nclus[f]->nsym[d]->ref[r];
              c_ijkl[r][0]=noccupancy[ijk].site[ll].neighbors[temp]->ijk;
              c_ijkl[r][1]=noccupancy[ijk].site[ll].neighbors[temp]->l;

              c_occu[r]=noccupancy[c_ijkl[r][0]].site[c_ijkl[r][1]].atomtype;
              product *=c_occu[r];
            }//end for (int r=0;r<n;r++)

            if (product>0)//if cluster does not contain vacancy
            {
              V_old=get_Vin(ll, n, f, c_occu);//get Vin of cluster
              //cout<<" eEnergy line 51"<<endl;
            }

            //E0+=((product>0)*V_old)/n;
            E0+=V_old/n;

            //Check on correctness of above equation
          }
        }//endfor (int f=0;f<clustree.sublat[ll].nbody[n].......)
      }	
    }	
  }//end for (int ijk=0; ijk<nsize;ijk++)
  return E0;
}

//EOF
