//This file is "get_vin.cc"
//Func. definition of member func. of the Lattice class.
//By Teck Leong Tan

#include "lattice.h"

//This func. returns Vin for given occupation, c_occu[]
double Lattice::get_Vin(int l, int n, int f, int c_occu[])
{
  int index=0;
  //Loop over nbody
  for(int i=0;i<n;i++)
  {
    //Convert from c_occu[] array form to index form.
    index+=((c_occu[i]-1)*power(num_type,(n-i-1)));
  }
  if (index<0)
  {
    cout<<"pot.cc line 19: Index cannot be negative"<<endl;
    exit(1);
  }
  if(index>=clustree.sublat[l].nbody[n].nclus[f]->Vin.size()){
    cerr<<"Error in get_Vin.cc: index="<<index<<"  Index exceeds ";
    cerr<<"clustree.sublat["<<l<<"].nbody["<<n<<"].nclus["<<f<<"]->Vin.size()= ";
	  cerr<<clustree.sublat[l].nbody[n].nclus[f]->Vin.size()<<endl;
    exit(1);
  }
  return clustree.sublat[l].nbody[n].nclus[f]->Vin[index];
}

//EOF 
