/* This file is linear_index.cc
   Function definition of member function of class Lattice
   By Teck Leong Tan
*/

#include "lattice.h"

int Lattice::linear_index(const int nbody, const vector<int> &indices)
{
  int index=0;
  //Loop over nbody
  for(int i=0;i<nbody;i++)
  {
    //Convert from indices form to linear index form.
    if (indices[i]<=0)
    {
      cerr<<"Error in linear_index.cc. indices must be greater than 0"<<endl;
      exit(1);
    }
    index+=((indices[i]-1)*power(num_type,(nbody-1-i)));
  }
  return index;
}

//See lattice.h for explanation
//EOF
