//This is the main function of an MC code for cluster expansion
//By Teck Leong Tan
#include <vector>
#include <iostream>
#include <fstream>
#include <cstring>
//#include <cstddef>
//#include <cstdlib>
#include <string.h>
#include <math.h>
#include <algorithm>
#include "lattice.h"
#include "power.h"
#include "filenames.h"
#include "cor_coord.h"
#include "inversion.h"
//#include "keywords.h"
#define CHARMAX 30
using namespace std;

const extern double Vlargenum=1.0e27; //A global variable
int main ()
{
  //Testing ground for Structural inversion======================================================  
  
  /*Inversion Inv;//once declared matrix structure will be read
  Inv.lfit();
  cout<<"lfit() done"<<endl;
  Inv.print_matrix("out_struct.txt");*/

  //============================================================================================= 

 
  Lattice Lat;
    
  Lat.read_input();//Read simulation inputs from file
  //delete [] key_array;
  cout<<"end of reading input"<<endl;

  Lat.create_noccupancy();//Initialises noccupancy
  Lat.read_neighbor();//Read in the neighbors
  Lat.read_clus();//Read in the cluster tree
  cout<<"end of read neighbor"<<endl;
  //Obtain interaction potentials (by sinversion or read from file)

  if (Lat.sinv_option==1)
    Lat.sinversion();
  else
  Lat.read_Vin();

  if (Lat.correlation_option==1)
  {
    Lat.create_corn();//Initialise the neighbor list for correlations (SRO)
  }
  cout<<"end of initialising"<<endl;
    
  Lat.print_param();//Prints out the parameters of the MC run
 
  /*cout<<"after closing"<<endl;
  cout<<"factor[0]= "<<Lat.factor[0]<<endl;
  cout<<"factor[1]= "<<Lat.factor[1]<<endl;*/

  
 // Grand Canonical MC part--outcor_LRO.txt-----------------------------------------
  Lat.monte_carlo();
 
  //cout<<"pot, line25, size of onebody "<<Lat.Pots.onebody.size()<<endl;
  //cout<<"pot, line25, size of twobody "<<Lat.Pots.twobody.size()<<endl;
  //cout<<"line 30 onebody[0] "<<Lat.Pots.onebody.at(0)<<endl;
  //cout<<"line 30 onebody[0] "<<Lat.Pots.onebody.at(1)<<endl;
  //cout<<"line 32 twobody["<<1<<"]= "<<Lat.Pots.twobody.at(0)<<endl;
  //cout<<"line 32 twobody["<<1<<"]= "<<Lat.Pots.twobody.at(0)<<endl;
  //cout<<"line 32 twobody["<<1<<"]= "<<Lat.Pots.twobody.at(1)<<endl;
  //cout<<"line 32 twobody["<<1<<"]= "<<Lat.Pots.twobody.at(1)<<endl;
  //delete [] key_array;
  cout<<"End of Main Program"<<endl;
  
}      




