//This file is metro_grand.cc
//Definition of a member function of class Lattice
//By Teck Leong Tan

#include "lattice.h"
//extern int ndim, num_type;
//extern int nrep[3];// No. of cell repetitions in each direction
//extern int nsize; //nsize is the no. of atoms

void Lattice::metro_grand(double T, int pass)
{
  double beta; 
  beta=1.0/T;
  double Probability=0;
  int random;
  double dou_random;
  int noccu, noccu_new;
  double dE;
  //Loop over cell (ijk)
  for (int ijk=0; ijk<nsize;ijk++)
  {
    //Loop over sublattice
    for (int l=0; l<num_sublat;l++)
    {
      noccu_new=rand()%(num_type);//num_type choices: 0,1,2...type-1
      noccu=noccupancy[ijk].site[l].atomtype;
    
      if (noccu_new>=noccu) // ensure occupancy != old occupancy
      {
        noccu_new++;
      }
      
      dE=denergy(ijk, l, noccu_new);//Calculates dE.

      //cout<<endl;
      //cout<<"dE= "<<dE <<endl;
      
      //Accept or reject?-----------------------------------------
      if( dE <= 0 )
      {
	      //accept:
	      noccupancy[ijk].site[l].atomtype=noccu_new;
	      //cout<<"Move accepted with P=1"<<endl;
	      //E_struct.dEacc=E_struct.dEacc+E_struct.dE;
      }
      else
      {
	      Probability=exp(-dE*beta);
	      dou_random=(double)rand()/(double)RAND_MAX;//Produce rand. no. drom 0 to 1;
        //cout<<"RANDMAX= "<<RAND_MAX<<endl;  
        //cout<<"Raw random no.= "<<rand()<<endl;
        //cout<<"Rand no. gen. for this move= "<<dou_random<<endl;
	if (Probability>dou_random)
	{
	  //accept:
 	  noccupancy[ijk].site[l].atomtype=noccu_new;
 	  //cout<<"Rand no. gen. for this move= "<<dou_random<<endl;
	  //cout<<"Move accepted with P= "<<Probability<<endl;
	  //E_struct.dEacc=E_struct.dEacc+E_struct.dE;
	}
	else
	{
	  //reject:
	  dE=0;
 	  //cout<<"Rand no. gen. for this move= "<<dou_random<<endl;
	  //cout<<"Move rejected with P= "<<Probability<<endl;
	}
      }
      //End of accept or reject portion----------------------------

      E_struct.dEpass+= dE;//dEpass denotes change in energy with respect to Estart. 
      //if no. of passes >= no. of passes for equilibration
      if (pass>equil_pass)
      {
	  //cout<<"dE= "<<dE<<endl;
	  //cout<<"noccupancy: "<<endl;
        /*for (int ijk=0; ijk<nsize; ijk++)
        { //Loop over sublattice
          for (int l=0; l<num_sublat;l++)
          {
            cout<<" "<<noccupancy[ijk].site[l].atomtype;
          }
          for (int i=ndim-1;i>0;i--)
          {
            if ((ijk+1)%factor[i]==0) { cout<<endl; }
       
          }
	  }//end for (int ijk=0; ijk<nsize; ijk++)*/
        //cout<<"Estart= "<<E_struct.Estart<<" dEpass= "<<E_struct.dEpass;
        //cout<<" E= "<<E_struct.Estart+E_struct.dEpass<<endl;
      }//end_if (pass>equil_pass)
    }//end for (int l=0; l<num_sublat;l++)
  }//end (int ijk=0; ijk<nsize;ijk++)
}

//EOF


