/* This file is print_corr.cc 
   Prints the correlation terms
   By Teck Leong Tan
*/

#include "lattice.h"

void Lattice::print_corr(fstream& out,int countpass, double T)
{
    //out<<endl;
  for (int ll=0; ll<num_sublat;ll++)
  {
    for (int nei=0;nei< noccupancy[0].site[ll].cor_pair.size();nei++)
    {
      int counter=0;
      for (int i=0;i<num_type;i++)
      {
        for (int j=i+1;j<=num_type;j++)
        {
          out<<T<<"  0 "<<ll<<"  ";
          out<<noccupancy[0].site[ll].cor_pair[nei]->ijk<<" ";
          out<<noccupancy[0].site[ll].cor_pair[nei]->l<<"  ";
          out<<i<<" "<<j<<"  ";
 
          //Output <P(ll1,i)> averaged over 1st atom's sublat;
          out<<setw(6)<<setprecision(4)<<((double)noccupancy[0].site[ll].sub_instances[i]\
                /(double)countpass/(double)nsize)<<" ";

          int ll2;
          ll2=noccupancy[0].site[ll].cor_pair[nei]->l;

          //Output <P(ll2,i)> averaged over 2nd atom's sublat;
          out<<setw(6)<<setprecision(4)<<((double)noccupancy[0].site[ll2].sub_instances[j]\
                /(double)countpass/(double)nsize)<<"  ";          
          /*
          //The following formular calculates the SRO for single sublattice. 
          //It serves just as a guide. The user should be clear of what it entails before 
          //activating this.
          double SRO;
          SRO=1-(double)noccupancy[0].site[ll].cor_pair[nei]->num_instances[counter]\
              /(double)countpass/(double)nsize/C_struct.conc_avg[i]/C_struct.conc_avg[j];
          out<<SRO<<endl;
          */
          
          out<<setw(6)<<setprecision(4)<<((double)noccupancy[0].site[ll].cor_pair[nei]->num_instances[counter]\
                /(double)countpass/(double)nsize)<<endl;//Output <P(x,i),P(y,j)>
          counter++;
        }//end for (int j=i+1;j<=num_type;j++)
      }
    }
  }//end for (int ll=0; ll<num_sublat;ll++)

}
//EOF
            
