/* This file is tensor_index.cc
   Function definition of member function of class Lattice
   By Teck Leong Tan
*/

#include "lattice.h"

void Lattice::tensor_index(const int nbody, const int lindex, vector<int> &tensor)
{
  int linear=lindex;
  //Loop over no. of bodies
  for (int j=0;j<nbody;j++ )
  {
    //Change from linear index to tensor index by successive division
    tensor[j]=linear/(power(num_type,(nbody-j-1)));
    linear=linear%power(num_type,(nbody-j-1));
  }
}
//EOF
