//This file is trans_vectors.cc
//Definitions of some member func. of the Trans_vectors class
//By Teck Leong Tan

#include "trans_vectors.h"

void Trans_vectors::cal_volume()
{
  int ndim=vecs.size();
  
  if (ndim==1)
  {
    volume=sqrt(dot_prod(vecs[0],vecs[0]));
  }

  else if (ndim==2)
  {
    vector<double> result;
    cross_prod(vecs[0],vecs[1],result);
    volume=sqrt(dot_prod(result, result));
  }

  else if (ndim==3)
  {
    vector<double>result;
    cross_prod(vecs[0],vecs[1],result);
    volume=fabs(dot_prod(result,vecs[2]));
  }

  else 
  {
    cout<<"Error in trans_vectors.cc: No. of dimensions";
    cout<<" larger than 3. Higher dimension volume not calculated";
  }
}

double Trans_vectors::dot_prod(const vector<double> &a, const vector<double> &b)
{
  int dim =a.size();
  if (dim!=b.size())
  {cerr<<"Error in trans_vectors.cc: Vector sizes must be the same for dot product"<<endl; 
   exit(1);}
  double dot_prod=0;
  for (int k=0;k<dim;k++)
  {
    dot_prod+=(a[k]*b[k]);
  }
  return dot_prod;
}

void Trans_vectors::cross_prod( vector<double> a, vector<double> b,\
                               vector<double> &result)
{
  int ndim=a.size();
  if (ndim!=b.size())
  {cerr<<"Error in trans_vectors.cc: Vector sizes must be the same for cross  product"<<endl; 
   exit(1);
  } 
  for (int i=0;i<3-ndim;i++)
  {
    a.push_back(0);
    b.push_back(0);
  }
  result.assign(3,0);
  //int check=-1;
  
  for (int i=0;i<3;i++)
  {
    //check*=-1;
    result[i]=a[(i+1)%3]*b[(i+2)%3]-a[(i+2)%3]*b[(i+1)%3];
  }
}
//Eof
